package com.dcore.catsalut.servlet;

import com.dcore.catsalut.acces.CookiesPortalUtil;
import com.dcore.catsalut.acces.UsuariPortalBean;
import com.dcore.catsalut.crida.AltaOcurrencies;
import com.dcore.catsalut.crida.ConnexioBD;
import com.dcore.catsalut.crida.ConsultarOcurrencia;
import com.dcore.catsalut.crida.InspeccioElectronica;
import com.dcore.catsalut.crida.ModificacioOcurrencia;
import com.dcore.catsalut.crida.ValidarUsuari;
import com.dcore.catsalut.model.Ocurrencia;
import com.dcore.catsalut.model.OcurrenciaForm;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import java.io.OutputStream;

import java.math.BigDecimal;

import java.sql.Connection;

import java.util.ArrayList;

import java.util.Collections;
import java.util.Enumeration;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import oracle.xdb.XMLType;

import org.apache.commons.codec.binary.Base64;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import resources.ERIBResources;


/**
 * Servlet implementation class ShowXML
 */

public class ShowXML extends HttpServlet {
	private static final long serialVersionUID = 1L;
	
	// Variables carregades de properties
	private static String ID_VAR_LABEL = ERIBResources.getPropietat("ID_VAR_LABEL");
	private static String ID_VAR_APLICACIO = ERIBResources.getPropietat("ID_VAR_APLICACIO");
	private static String ID_VAR_REGISTRE = ERIBResources.getPropietat("ID_VAR_REGISTRE");
	private static String ID_VAR_NIVELL = ERIBResources.getPropietat("ID_VAR_NIVELL");
	private static String ID_VAR_LLIGAM = ERIBResources.getPropietat("ID_VAR_LLIGAM");
	private static String ID_VAR_VARIABLE = ERIBResources.getPropietat("ID_VAR_VARIABLE");
	private static String ID_VAR_LLISTA_CAMPS = ERIBResources.getPropietat("ID_VAR_LLISTA_CAMPS");
	private static String ID_OBLIGATORI = ERIBResources.getPropietat("ID_OBLIGATORI");
	private static String ID_NOM_FORMULARI = ERIBResources.getPropietat("ID_NOM_FORMULARI");
	private static String ORDRE = ERIBResources.getPropietat("ID_ORDRE");
	private static String ID_REQUADRE = ERIBResources.getPropietat("ID_REQUADRE");
	private static String NOM_REQUADRE = ERIBResources.getPropietat("ID_NOM_REQUADRE");
	private static String USUARI = ERIBResources.getPropietat("USUARI");

	//private ArrayList dadesForm = new ArrayList();   
	/**
	 * @see HttpServlet#HttpServlet()
	 */
	public ShowXML() {
		super();
		// TODO Auto-generated constructor stub
	}
	public class Formulari{
		 tractamentFormulari( String e){
			if(e.getMessage().contains("anulada")){
				s1 = "Formulari anulat, si us plau refresqueu la pantalla de la Bstia de Inspeccions.";
			}
			else if (e.getMessage().contains("tractada")){
				s1 = "Formulari ja tractat, si us plau refresqueu la pantalla de la Bstia de Inspeccions.";
			}
			else if (e.getMessage().contains("<missatge>")){
				s1 = "Error carregant" + e.getMessage().substring(e.getMessage().indexOf("carregant")+
						"carregant".length(), e.getMessage().indexOf("</missatge>"))+ ". ERROR: S'ha produt un problema en el moment d'obtenir la inspecci electrnica.";
			}else{
				//s1 = e.getMessage();
				s1 = "ERROR: S'ha produt un problema en el moment d'obtenir la inspecci electrnica";
			}
		     return s1;
		  }
	}
	
	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	@SuppressWarnings("unchecked")
	
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {            

		Ocurrencia o = new Ocurrencia();
		ArrayList<Ocurrencia> ocurList = new ArrayList<Ocurrencia>();
		ArrayList<OcurrenciaForm> ocurFormList = new ArrayList<OcurrenciaForm>();
		ArrayList<String> llistaValors = new ArrayList<String>();


		String xml_cons = null;
		String xml_inspec = null;
		String xml_alta = null;
		String xml_modif = null;
		String s1 = null;
		String altaFeta = null;

		Connection con = null;
		String protocol = null;
		String idDoc = null;
		String numInsp = null;
		String tipus = null;
		String inspector = null;

		String user = null;
		String perfil_user = null;
		String cod = null;


		System.out.println("INFO: doGet");


		try {
			CookiesPortalUtil cpu = new CookiesPortalUtil(request);
			UsuariPortalBean upb = new UsuariPortalBean();
			ValidarUsuari vu = new ValidarUsuari();

			request.getSession().removeAttribute("validaUser");
			System.out.println("DEBUG: sessionId " + request.getSession().getId());
			//con = ConnexioBD.getConnetion();

			//obtenim la Cookie per comprovar que l'usuari tingui accs a l'aplicaci

			upb = cpu.getUsuariPortal();              
			//obtenim nom d'usuari i el seu perfil      
			user = upb.getUsuari();                     
			perfil_user = upb.getPerfil();             

			inspector = user;
			request.getSession().setAttribute("inspector", inspector);

			//Si la funci ens retorna '0' l'usuari t accs
			cod = vu.ValidaUsuari(user, perfil_user);

			//cod = "0";//SGT
			request.getSession().setAttribute("validaUser", cod);

			//si valida l'usuari correctament al sistema
			if (cod.equals("0")){
				System.out.println("INFO: t accs!!");

				try {
					// inicialitzar resultat
					request.getSession().setAttribute("errorRes","");
					request.getSession().removeAttribute("errLoad");
					request.getSession().removeAttribute("errMessageIns");
					request.getSession().removeAttribute("errMessageMap");
					request.getSession().removeAttribute("altaFeta");
					request.getSession().removeAttribute("tipus");
					request.getSession().removeAttribute("altaOK");
					request.getSession().setAttribute("errorComplet", "");

					//obtenim parmetres de la url, sino de la sessi
					if (request.getParameter("proto") != null && !request.getParameter("proto").equals("")){
						protocol = request.getParameter("proto");
						request.getSession().setAttribute("protocol", protocol);
					}else{
						protocol = (String)request.getSession().getAttribute("protocol");
					}

					if (request.getParameter("idocu") != null && !request.getParameter("idocu").equals("")){
						idDoc = request.getParameter("idocu");
						request.getSession().setAttribute("idocu", idDoc);
					}else{
						idDoc = (String)request.getSession().getAttribute("idocu");
					}

					if (request.getParameter("ninsp") != null && !request.getParameter("ninsp").equals("")){
						numInsp = request.getParameter("ninsp");
						request.getSession().setAttribute("numInsp", numInsp);
					}else{
						numInsp = (String)request.getSession().getAttribute("numInsp");
					}

					if (request.getParameter("tipus") != null && !request.getParameter("tipus").equals("")){
						tipus = request.getParameter("tipus");
						request.getSession().setAttribute("tipus", tipus);
					}else{
						tipus = (String)request.getSession().getAttribute("tipus");

					}                                  

					System.out.println("DEBUG: tipus" + tipus);
					
					//Obtenim la connexi
					try{
						con = ConnexioBD.getConnection();

					}catch (Exception e){
						throw e;
					}

					if (tipus == null || tipus.equals("")){
						System.out.println("INFO: carrega dades inspeccio");
						ConsultarOcurrencia co = new ConsultarOcurrencia();
						InspeccioElectronica ie = new InspeccioElectronica();

						//Generem els XMLs necessaris per fer les corresponents crides al servei de RSA 
						xml_cons = co.generar_XML_consulta(protocol);
						xml_inspec = ie.generar_XML_inspeccio(idDoc);

						//Amb els parmetres corresponents, procedim a consultar la Ocurrncia(xml) i						
						try{
							request.getSession().setAttribute("mapeigTrobat",""); //inicialitzem a res l'atribut de sessio mapeigTrobat
							XMLType xmlConsOcur = co.consultaOcurrencia(con, xml_cons);

							ocurList = o.getValorsOcurrenciaXML(xmlConsOcur, ID_VAR_LABEL, ID_VAR_APLICACIO, ID_VAR_REGISTRE, ID_VAR_NIVELL, ID_VAR_LLIGAM, ID_VAR_VARIABLE, ID_VAR_LLISTA_CAMPS,ID_OBLIGATORI,
									ORDRE,ID_REQUADRE,NOM_REQUADRE,ID_NOM_FORMULARI);

							System.out.println("INFO: getValorsOcurrenciaXML");
							//Obtenim el PDF a mostrar
							
							/*xml_cons = co.generar_XML_consulta(request.getParameter("idocu"));
							XMLType xmlConsPDF = co.consulta(con, xml_cons,
									new BigDecimal(ERIBResources.getPropietat("REGISTRE_I")),
									new BigDecimal (ERIBResources.getPropietat("ID_CONSULTA_PDF")),
									ERIBResources.getPropietat("APLICACIO"),
									ERIBResources.getPropietat("USUARI"));
							//System.out.println("DEBUG: " + xmlConsPDF.getStringVal().substring(1,300));
							NodeList nlist = null;
							if (xmlConsPDF != null && xmlConsPDF.getDOM() != null){
								nlist = xmlConsPDF.getDOM().getElementsByTagName("VAL");//
							}
							String PDF = "";
							if (nlist != null && nlist.getLength() > 0){
								//if (nlist.item(0).getAttributes() != null && nlist.item(0).getAttributes().getNamedItem("CODI") != null){
								if (nlist.item(0).getChildNodes() != null && nlist.item(0).getChildNodes().item(0) != null &&  nlist.item(0).getChildNodes().item(0).getNodeValue() != null){
									//PDF = nlist.item(0).getAttributes().getNamedItem("CODI").getNodeValue();
									PDF = nlist.item(0).getChildNodes().item(0).getNodeValue();
								}
							}
							//request.getSession().setAttribute("PDF", ERIBResources.getPropietat("URL_PDF_1") + PDF + ERIBResources.getPropietat("URL_PDF_2"));
							byte[] decodedPDF = getDecodedInspeccio(PDF);
							//String contentPDF = new String (decodedPDF);
							
							System.out.println("DEBUG: decodedPDF " + decodedPDF);
							
							File temp = File.createTempFile("erib", ".tmp"); 
							
							FileOutputStream fos = new FileOutputStream(temp);
							fos.write(decodedPDF);
							fos.flush();
                            fos.close();
                            
							request.getSession().setAttribute("PDF", temp);
							
							byte[] decodedPDF = getDecodedInspeccio(PDF);
                                                         File pdf = new File("erib.pdf");
                                                         FileOutputStream fos = new FileOutputStream(pdf);
                                                         fos.write(decodedPDF);
                                                         fos.flush();
                                                         fos.close();*/

						}catch (Exception e) {
							/* request.getSession().setAttribute("errLoad", "errMapeig");
							request.getSession().setAttribute("errMessageMap", e.getMessage()); */
							request.getSession().setAttribute("mapeigTrobat","no"); //indiquem que no s'ha trobat el mapeig, utilitzat per motius de visualitzacio del requadre de dades inspecci
							System.out.println("DEBUG: mapeigTrobat no");
							try{//
								// intentem saber de quin formulari es tracta si es que es un formulari valid
								XMLType xmlConsNomForm = co.consulta(con, xml_cons,
										new BigDecimal(ERIBResources.getPropietat("REGISTRE_C")),
										new BigDecimal (ERIBResources.getPropietat("ID_CONSULTA_F")),
										ERIBResources.getPropietat("APLICACIO"),
										ERIBResources.getPropietat("USUARI")); 

								NodeList nl = null;
								if (xmlConsNomForm != null && xmlConsNomForm.getDOM() != null){
									nl = xmlConsNomForm.getDOM().getElementsByTagName("VAL");//
								}
								String nomFormulari = "";
								if (nl != null && nl.getLength() > 0){
									if ( nl.item(0).getFirstChild() != null){
										nomF ormulari = nl.item(0).getFirstChild().getNodeValue();//
									}
								}
								request.getSession().setAttribute("nom_formulari", nomFormulari);// posem a l'atribut de sessio nom_formulari el seu corresponent nom obtingut de la consulta


							}catch (Exception ex){// si no podem obtenir cap tipus de formulari perque no existeix, l'anomenarem "Sense definir"
								System.out.println("DEBUG: nom_formulari Sense definir");
								request.getSession().setAttribute("nom_formulari", "Sense definir");//
							}//
						}
						//l'Inspecci Electrnica(xml) per tal de generar el formulari web
						try{							
							System.out.println("INFO: inspeccioElectronica");
							XMLType xmlInspeccio = ie.inspeccioElectronica(con, xml_inspec);

							if (xmlInspeccio != null) {
								System.out.println("DEBUG: xmlInspeccio " + xmlInspeccio.getStringVal());       
							} else {
								System.out.println("DEBUG: xmlInspeccio empty");
							}
							ocurFormList = o.Ocur2OcurForm(ocurList, xmlInspeccio);

							//ens guardem el nom del formulari
							if(ocurList.size() > 0)// En cas que existeixi mapeig, la llista d'ocurrencies trindr valors, per tant els fiquem a la sessio
								request.getSession().setAttribute("nom_formulari", ("".equals(ocurList.get(0).getID_NOM_FORMULARI()))?"Sense definir":ocurList.get(0).getID_NOM_FORMULARI());


							//System.out.println("DEBUG: ocurFormList " + ocurFormList);
							//System.out.println("DEBUG: -A->" + ocurFormList.get(0).getID_NOM_FORMULARI());
							//System.out.println("DEBUG: -B->" + ocurList.get(0).getID_NOM_FORMULARI());

							System.out.println("INFO: punt validacio fi ie.inspeccioElectronica");

						}catch (Exception e) {
							e.printStackTrace();
							
//******************************FUNCIO TRACTAMENT DEL FORMULARI(anulada o tractada)***************************************************//
							s1 = tractamentFormulari(e);
							System.out.println("WARNING: " + s1);
							
							request.getSession().setAttribute("errLoad","errInsp");
							request.getSession().setAttribute("errMessageIns", s1);
						}



						Collections.sort(ocurFormList); 


						System.out.println("DEBUG: ocurFormList saved "+ ocurFormList);                                                
						request.getSession().setAttribute("valorsOcurForm", ocurFormList);

						//si fem una alta
					}else if (tipus.equals("alta")){
						System.out.println("INFO: Desar inspeccio");
						AltaOcurrencies ao = new AltaOcurrencies();
						ocurFormList = (ArrayList<OcurrenciaForm>)request.getSession().getAttribute("valorsOcurForm");
						
						System.out.println("DEBUG: ocurFormList" + ocurFormList);
						
						if (ocurFormList != null){
							String cont = request.getParameter("cont");//obtenim nmero d'ocurrencies
							/*
							 * En cas que numInsp es trobi a la request
							 * Obtenim el numInsp de la request i el fiquem a la sessio
							 * Sino, l'obtenim de la sessio
							 */
							if (request.getParameter("numInspec") != null && !request.getParameter("numInspec").equals("")){
								numInsp = request.getParameter("numInspec");
								request.getSession().setAttribute("numInsp", numInsp);
							}
							else
							{
								numInsp = (String)request.getSession().getAttribute("numInsp");
							}

							if(cont != null && (!(cont.equals("0")))){ //En cas que el formulari tingui mapeig <--> cont > 0, 
								//farem una alta i procedirem a modificar el tractament de la comunicacio
								String valLligam = null;
								int contInt = Integer.parseInt(cont);//el convertim a integer
								//desem els valors del formulari depenent si venen donats per desplegables o per camps de text

								for(int i=0; i<contInt; i++){

									if(ocurFormList != null && ocurFormList.get(i) != null && ocurFormList.get(i).getVALORS_COMBO() != null && ocurFormList.get(i).getVALORS_COMBO().size() > 0){
										valLligam = request.getParameter("cbo"+i);

									}else{
										valLligam = request.getParameter("valLligam"+i);//obtenim el valor del lligam (input text)fent la petici

									}

									//desem l'objecte a la arrayList amb el nou valor del lligam
									if (ocurFormList != null && ocurFormList.get(i) != null){
										ocurFormList.get(i).setValorLLIGAM(valLligam);
									}
								}

								try{
									System.out.println("INFO: generar_XML_alta");
									// fer alta passant xml
									xml_alta = ao.generar_XML_alta(ocurFormList);// generar xml
									System.out.println("INFO: altaOcurrencies" + numInsp);
									//inspector="TSRSA";//SGT

									ao.altaOcurrencies(con, xml_alta, USUARI, numInsp);
									altaFeta = "altaOK";
									request.getSession().setAttribute("altaFeta", altaFeta);

									//un cop feta l'alta, pels combos reestablim el valor del lligam que trobem a l'XML d'inspeccions
									//per mantenir els valors del combo seleccionats.
									for(int i=0; i<contInt; i++){
										//mirem si l'ocurrncia corresponent conte llista de valors
										if(ocurFormList != null && ocurFormList.get(i) != null && ocurFormList.get(i).getVALORS_COMBO() != null && ocurFormList.get(i).getVALORS_COMBO().size() > 0){
											//obtenim la llista
											llistaValors = ocurFormList.get(i).getVALORS_COMBO();
											if (llistaValors != null){
												//restablim el valor que inserim a rsa pel valor del lligam de l'XML d'inspeccions
												for( int j=2; j<llistaValors.size(); j=j+3){
													if(llistaValors.get(j) != null && ocurFormList.get(i) != null && llistaValors.get(j).equals(ocurFormList.get(i).getValorLLIGAM())){
														ocurFormList.get(i).setValorLLIGAM(llistaValors.get(j-2));
													}
												}
											}                                                                
										}
									}                                                        
									System.out.println("DEBUG: ocurFormList saved "+ ocurFormList);
									//enviem al jsp l'arraylist amb els nous valors
									request.getSession().setAttribute("valorsOcurForm", ocurFormList);
									request.getSession().setAttribute("altaOK", "yes");
									request.getSession().setAttribute("errorRes", "El registre s'ha inserit correctament");
									//Modificaci ocurrncia.
									ModificacioOcurrencia mo = new ModificacioOcurrencia();

									xml_modif = mo.generar_XML_modificacio(idDoc, inspector,numInsp);
									mo.modificacioOcurrencia(con, xml_modif, idDoc);

								}catch(Exception e){
									//Si ens dona error al fer l'alta, pels combos reestablim el valor del lligam que trobem a l'XML d'inspeccions
									//per mantenir els valors del combo seleccionats.
									for(int i=0; i<contInt; i++){
										//mirem si l'ocurrncia corresponent conte llista de valors
										if(ocurFormList != null && ocurFormList.get(i) != null && ocurFormList.get(i).getVALORS_COMBO() != null && ocurFormList.get(i).getVALORS_COMBO().size() > 0){
											//obtenim la llista
											llistaValors = ocurFormList.get(i).getVALORS_COMBO();
											if (llistaValors != null){
												//restablim el valor que inserim a rsa pel valor del lligam de l'XML d'inspeccions
												for( int j=2; j<llistaValors.size(); j=j+3){

													if(llistaValors.get(j)!= null && ocurFormList.get(i) != null && llistaValors.get(j).equals(ocurFormList.get(i).getValorLLIGAM())){
														try{
															ocurFormList.get(i).setValorLLIGAM(llistaValors.get(j-2));
														}catch (Exception ee){System.out.println("ERROR: exception " + ee.getMessage());}

													}
												}
											}						            
										}
									}

									request.getSession().setAttribute("errorComplet", e.getMessage());
									System.out.println("DEBUG: errorComplet:" + e.getMessage());
									if(e != null && e.getMessage() != null &&  e.getMessage().contains("missatge")){
										s1 = e.getMessage().substring(e.getMessage().indexOf("<missatge>")+"<missatge>".length(), e.getMessage().indexOf("</missatge>"))+ ".";

									}else { s1 = "El registre s'ha inserit correctament";}
									e.printStackTrace();
									request.getSession().setAttribute("errorRes", s1);  

								}
							} else { // En cas que el formulari no tingui mapeig <--> cont = 0 noms es modificar el tractament de la comunicacio
								try{
									System.out.println("INFO: formulari no te mapeig");
									//Modificaci ocurrncia.
									ModificacioOcurrencia mo = new ModificacioOcurrencia();
									xml_modif = mo.generar_XML_modificacio(idDoc, inspector, numInsp);
									mo.modificacioOcurrencia(con, xml_modif, idDoc);
									request.getSession().setAttribute("errorRes", "El registre s'ha inserit correctament");
								}catch(Exception ex){
									if(ex != null && ex.getMessage() != null && ex.getMessage().contains("missatge")){
										s1 = ex.getMessage().substring(ex.getMessage().indexOf("<missatge>")+"<missatge>".length(), ex.getMessage().indexOf("</missatge>"))+ ".";
										s1 = s1.substring(s1.indexOf("missatge")+"missatge".length()+4, s1.indexOf("/missatge")-5)+".";

									}
									request.getSession().setAttribute("errorRes", s1);
									ex.printStackTrace();
								}

							}
						}
					}

				}catch (Exception e){
					e.printStackTrace();
					throw e;									

				}finally{
					try {
						if ( !con.isClosed()){
							con.close();
						}
					}catch(Exception ex){
						ex.printStackTrace();
					}
				}

			}else {
				System.out.println("INFO: NO t accs");
				request.getSession().setAttribute("validaUser", "noUsuari");
			}
		} catch (Exception e) {
			e.printStackTrace();
			if (e.getMessage() != null && e.getMessage().contains("Error en al conectar base de dades")){
				request.getSession().setAttribute("validaUser", "errConnexio");
			}else if (e.getMessage() != null && e.getMessage().contains("USUARI NO CONNECTAT")) {
				request.getSession().setAttribute("validaUser", "noUsuari"); 
			} else if (e.getMessage().contains("Cursor is closed")){
				request.getSession().setAttribute("validaUser", "noPermisos");
			}else{
				request.getSession().setAttribute("validaUser", "errConnexio");
			}
		}finally{
			getServletConfig().getServletContext().getRequestDispatcher("/CampsForm.jsp").forward(request,response);
		}	
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		doGet(request,response);
	}


	/**
	 * Funci la qual li passem un String codificat en BASE64 i ens el retorna descodificat.
	 * not own
	 * @param encodedInspec
	 * @return decodedString
	 * @throws IOException
	 */
	private byte[] getDecodedInspeccio(String encodedInspec) throws IOException {
		byte[] decoded = Base64.decodeBase64(encodedInspec.getBytes());
		//String decodedString = new String(decoded);
		return decoded;
	}

	public static void convertByteArrayToDoc(byte[] b) {


		OutputStream out;
		try {           
			out = new FileOutputStream("C:/1.pdf");
			out.close();
			System.out.println("INFO: PDF write success");
		}catch (Exception e) {
			System.out.println("ERROR: No ha estat possible crear el PDF");
		}
	}

}
